#property indicator_chart_window //   
#property indicator_buffers 4
#property indicator_color1 Green // 
#property indicator_color2 Red // 
#property indicator_color3 Green // 
#property indicator_color4 Red // 


//  
extern double K=1; //  ATR
extern int Smooth=10; //  ATR
extern int WideMin=2; //     .
   double sens; //     

 int History=0; // 0-  

// .
double   Pk[],
         Tr[],
         Top[],
         Bot[]; // 

// 
void init()
  {
   sens=WideMin*Point;
   
   SetIndexBuffer(0,Pk);
   SetIndexStyle(0,DRAW_LINE,0,2);
   SetIndexEmptyValue(0,0.0);

   SetIndexBuffer(1,Tr);
   SetIndexStyle(1,DRAW_LINE,0,2);
   SetIndexEmptyValue(1,0.0);

   SetIndexBuffer(2,Top);
   SetIndexStyle(2,DRAW_LINE,2);

   SetIndexBuffer(3,Bot);
   SetIndexStyle(3,DRAW_LINE,2);

   Comment("RenkoWATR(",K,",",WideMin,")");
  }

// -  
int reinit() 
  {
   ArrayInitialize(Pk,0.0); //  
   ArrayInitialize(Tr,0.0); //  
   ArrayInitialize(Bot,0.0); //  
   ArrayInitialize(Top,0.0); //  
   return(0);
  }

void deinit()
  {
   Comment("");
  }

void start()
  {
   int ic=IndicatorCounted();
   if(Bars-ic-1>1) ic=reinit(); //        - 
   int limit=Bars-ic-1; // - 
   if(History!=0 && limit>History) limit=History-1; // -   

   for(int i=limit; i>=0; i--) { //     
      bool reset=i==limit && limit>1; //      

      static double Brick=0,Up=0,Dn=0;
      double BricksUp=0,BricksDn=0;
      double H=High[i]; double L=Low[i]; double C=Close[i];
      if(reset) {
         Brick=MathMax(K*(H-L),sens);
         Up=H; Dn=L;
        }

      double Value1=iATR(NULL,0,Smooth, i);
        
      if(C>Up+Brick) {
         if(Brick==0) BricksUp=0; else BricksUp=MathFloor((C-Up)/Brick)*Brick;
         Up=Up+BricksUp;
         Brick=MathMax(K*Value1,sens);
         Dn=Up-Brick;
         BricksDn=0;
        }
      if(C<Dn-Brick) {
         if(Brick==0) BricksDn=0; else BricksDn=MathFloor((Dn-C)/Brick)*Brick;
         Dn=Dn-BricksDn;
         Brick=MathMax(K*Value1,sens);
         Up=Dn+Brick;
         BricksUp=0;
        }
      //  
      Top[i]=Up; Bot[i]=Dn;
      // 
      static bool dir;
      if(Top[i+1]<Top[i]) dir=1;
      if(Bot[i+1]>Bot[i]) dir=0;
      if(dir)  Pk[i]=Bot[i]-Brick;
      else     Tr[i]=Top[i]+Brick;
      
     }   
  }



